/*
 * EA_MultiObj.hpp
 *
 *  Created on: Mar 18, 2015
 *      Author: Joost Huizinga
 */

#ifndef EA_MULTIOBJ_HPP_
#define EA_MULTIOBJ_HPP_

#include <Ind_WrapMultiObj.hpp>
#include <fstream>
#include <iostream>
#include <vector>


template<typename Fit>
class MultiObjective
{
public:
    typedef typename Fit::indiv_t indiv_t;
    typedef std::vector<indiv_t> pop_t;
    typedef std::vector<pop_t> front_t;


    MultiObjective(){
        //nix
    }

    /**
     * Initializes the population (parent) of the hill climber.
     *
     * Implement this function such that it:
     * - assigns the fitness function
     * - initializes the population with copies of the initial individual
     * - randomizes the population
     * - evaluates the population
     */
    void init(indiv_t initialIndividual,
            Fit fitnessFunction,
            size_t populationSize){
        /* TODO: YOUR CODE HERE */

    }

    /**
     * Runs one epoch (usually a generation) of the evolutionary algorithm.
     *
     * Implement this function such that:
     * - parents are selected according to Pareto based tournament selection with tournament size 2.
     *   That is, randomly select two competitors from the population.
     *   If one of the competitors dominates the other, the non-dominated individual is the winner.
     *   Otherwise, select the winner at random.
     * - each parent produces one child that is a copy of himself
     * - the child is mutated and evaluated
     * - the new population is selected from the old population and the children based on Pareto ranking.
     *   That is, first create a mixed population that contains both parents and children.
     *   Then, select all non-dominated individuals and add them to the new population until the new population is full
     *   (that is, contains a number of individuals equal to the population size set in the init function).
     *   If there is still room in the new population, repeat
     *   the process on the remaining individuals of the mixed population.
     *   You do not have to implement crowding (diversity on the Pareto front), but you do have to make sure that,
     *   if there are multiple individuals with the exact same performance on all objectives,
     *   only one of those individuals is added per layer.
     *
     * Refer to the Ind_WrapMulitObj.hpp file for methods you can use to retrieve the performance
     * of an individual on different objectives.
     */
    void epoch(){
        /* TODO: YOUR CODE HERE */

    }


    /**
     * Returns the Pareto front.
     */
    const pop_t &getParetoFront() const{
        return fronts[0];
    }



    /**
     * Returns the current population.
     */
    const pop_t &getPopulation() const{
        return _population;
    }

    /* TODO: MORE CODE HERE IF YOU LIKE */

private:
    pop_t _population;
    front_t fronts;
    Fit _fitnessFunction;
};




#endif /* EA_MULTIOBJ_HPP_ */
