/*
 * Fit_MultiObjDistLong.hpp
 *
 *  Created on: Mar 18, 2015
 *      Author: Joost Huizinga
 */

#ifndef FIT_MULTIOBJDISTLONG_HPP_
#define FIT_MULTIOBJDISTLONG_HPP_

#include "Ind_WrapMultiObj.hpp"
#include "btBulletDynamicsCommon.h"

template<typename SimType, typename Indiv>
class Fit_MultiObjDistLong
{
public:
    typedef Indiv indiv_t;

    Fit_MultiObjDistLong(SimType* simulator = 0){
        _simulator = simulator;
    }


    /**
     * Function that evaluates an individual and adds the relevant objectives.
     *
     * Implement such that it adds two objectives:
     * - The distance the individual traveled after 1000 time-steps from its starting location.
     * - The maximum distance between any of the individuals blocks.
     *   Measure this distance before the robot started moving.
     * 
     * You can add an objective to an individual with:
     *   individual.addObjective(objective);
     *
     * Do not forget to clear the objectives before adding new ones.
     * Clear objectives with:
     *   individual.clearObjectives()
     */
    void evaluate(indiv_t& individual){
        /* TODO: YOUR CODE HERE */

    }



private:
    SimType* _simulator;
};




#endif /* FIT_MULTIOBJDISTLONG_HPP_ */
