#!/usr/bin/python
import sys
import matplotlib
import matplotlib.pyplot as plt
import matplotlib.cm as cm
   
def readFile(filename):
   inputFile = open(filename, 'r')
   matrix = []

   inputFile.seek(0)
   for line in inputFile:
      line = line.strip()
      numbers  = line.split()
      row = []
      for number in numbers:
         row.append(float(number))
      matrix.append(row)
   inputFile.close()

   return matrix

def plot(matrix):
   x_max = 0
   y_max = 0
   x_data = []
   y_data = []
   c_data = range(len(matrix))
   for i in  c_data:
      row = matrix[i]
      x_data.append([])
      y_data.append([])
      for j in xrange(0, len(row), 2):
         if x_max < row[j]:
            x_max = row[j]
         if y_max < row[j+1]:
            y_max = row[j+1]
         x_data[i].append(row[j])
         y_data[i].append(row[j+1])

   normalize_class = matplotlib.colors.Normalize()
   colorMap = matplotlib.cm.ScalarMappable(norm=normalize_class, cmap="jet")
   colorMap.set_array(c_data)
   colors = colorMap.to_rgba(c_data)
   
   for i in c_data:
      plt.plot(x_data[i], y_data[i], marker='*', c=colors[i])
  
   plt.xlim([0, x_max+0.5])
   plt.ylim([0, y_max+0.5])
   #plt.scatter(x_data, y_data, s=10, c=c_data, cmap=cm.YlOrRd, vmin = 0, vmax = 25)
   #for row in matrix:
    #  plt.scatter(row[1], row[2], s=10, c=row[0], cmap=cm.Spectral, vmin = 0, vmax = 25, alpha=0.5)
   #cbar=plt.colorbar()
   #cbar.ax.set_yticklabels([0, 25])
   #cbar.set_label(r'Generations')
   color_bar = plt.colorbar(colorMap)
   color_bar.set_label("Generations") 

for arg in sys.argv[1:]:
   matrix = readFile(arg)
   plot(matrix)
   plt.xlabel("Distance")
   plt.ylabel("Length")
   plt.savefig(arg + ".pdf")
   


